#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m;
    cin >> n >> m;
    vector<string> f(n);
    for (int i = 0; i < n; i++) {
        cin >> f[i];
    }

    vector<vector<int>> pref(n);
    for (int i = 0; i < n; i++) {
        pref[i].resize(m + 1);
        for (int j = 0; j < m; j++) {
            pref[i][j + 1] = pref[i][j] + (f[i][j] == 'X');
        }
    }

    int b = m;
    for (int d = 1; d <= m; d++) {
        if (m % d == 0) {
            bool ok = true;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j += d) {
                    int s = pref[i][j + d] - pref[i][j];
                    if (s != 0 && s != d) {
                        ok = false;
                    }
                }
            }
            if (ok) {
                b = min(b, m / d);
            }
        }
    }

    pref.resize(m);
    for (int j = 0; j < m; j++) {
        pref[j].resize(n + 1);
        for (int i = 0; i < n; i++) {
            pref[j][i + 1] = pref[j][i] + (f[i][j] == 'X');
        }
    }

    int a = n;
    for (int d = 1; d <= n; d++) {
        if (n % d == 0) {
            bool ok = true;
            for (int j = 0; j < m; j++) {
                for (int i = 0; i < n; i += d) {
                    int s = pref[j][i + d] - pref[j][i];
                    if (s != 0 && s != d) {
                        ok = false;
                    }
                }
            }
            if (ok) {
                a = min(a, n / d);
            }
        }
    }

    cout << a << " " << b << endl;
    for (int i = 0; i < n; i += n / a) {
        for (int j = 0; j < m; j += m / b) {
            cout << f[i][j];
        }
        cout << "\n";
    }

    return 0;
}