#include <bits/stdc++.h>

long long MAX = (long long)1e12;

long long dfs(std::map<std::string, std::vector<std::string>> &graph,
         std::set<std::string> &was,
         std::map<std::string, long long> &dp,
         std::string &v) {
  was.insert(v);
  if (graph[v].size() == 0) {
    return dp.find(v) == dp.end() ? MAX : dp[v];
  }
  long long sum = 0;
  for (auto &u : graph[v]) {
    if (was.count(u) == 0) {
      long long uv = dfs(graph, was, dp, u);
      sum = std::min(MAX, sum + uv);
    }
  }
  if (dp.find(v) != dp.end()) {
    dp[v] = std::min(dp[v], sum);
  } else {
    dp[v] = sum;
  }
  return dp[v];
}

int main() {
  int n;
  std::cin >> n;
  std::vector<std::string> ingredients(n);
  std::map<std::string, long long> dp;
  for (int i = 0; i < n; i++) {
    std::cin >> ingredients[i];
    dp[ingredients[i]] = MAX;
  }
  int m;
  std::cin >> m;
  for (int i = 0; i < m; i++) {
    std::string s;
    int cost;
    std::cin >> s >> cost;
    dp[s] = cost;
  }
  int k;
  std::cin >> k;
  std::map<std::string, std::vector<std::string>> graph;
  for (int i = 0; i < k; i++) {
    int c;
    std::cin >> c;
    std::string ing;
    std::cin >> ing;
    for (int j = 0; j < c; j++) {
      std::string s;
      std::cin >> s;
      graph[ing].push_back(s);
    }
  }
  std::set<std::string> used;
  for (const auto &v : graph) {
    std::string s = v.first;
    if (used.count(s) == 0) {
      dfs(graph, used, dp, s);
    }
  }
  long long answer = 0;
  for (auto ing : ingredients) {
    answer = std::min(MAX, answer + dp[ing]);
  }
  printf("%lld\n", answer == MAX ? -1 : answer);
  return 0;
}
