#include <bits/stdc++.h>
#include "testlib.h"
#define err(...) fprintf(stderr, __VA_ARGS__), fflush(stderr)

using namespace std;

typedef long long ll;

const int maxN = (int)1e5;
const int maxM = (int)1e5;

vector<int> used;
vector<vector<int>> E;

void dfs(int v) {
	used[v] = 1;
	for (int to : E[v]) if (!used[to]) dfs(to);
}

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    
    int n = inf.readInt(1, maxN, "n");
    inf.readSpace();
    int m = inf.readInt(0, maxM, "m");
    inf.readEoln();
    
    E.resize(n);
    
    set<pair<int, int> > S;
    for (int i = 0; i < m; i++) {
    	int a, b;
    	a = inf.readInt(1, n, "a_i"); inf.readSpace();
    	b = inf.readInt(1, n, "b_i"); inf.readEoln();
    	if (a > b) swap(a, b);
    	ensuref(a != b, "graph contains self-loop, (%d, %d)", a, b);
    	ensuref(S.insert({ a, b}).second, "multiple edges, (%d, %d)", a, b);
    	E[a - 1].push_back(b - 1);
    	E[b - 1].push_back(a - 1);
    }
    
    used.assign(n, 0);
    dfs(0);
    int con = *min_element(used.begin(), used.end());
    
    ensuref(con, "graph isn't connected");
    inf.readEof();
	return 0;
}